diff --git a/target/linux/mxs/image/Config.in b/target/linux/mxs/image/Config.in
index b71edf7ccc89a3bc2640ec809866a63f08f8e5b5..250553e35665628bab2314de3ff4950507761ca9 100644
--- a/target/linux/mxs/image/Config.in
+++ b/target/linux/mxs/image/Config.in
@@ -1,5 +1,8 @@
-config MXS_SD_BOOT_PARTSIZE
+config TARGET_BOOTFS_PARTSIZE
 	int "Boot (SD Card) filesystem partition size (in MB)"
-	depends on TARGET_mxs
+	depends on TARGET_mxs_olinuxino-maxi || TARGET_mxs_olinuxino-micro
 	default 8
-
+	help
+	    On the Olimex OLinuXino boards, mainline U-Boot loads the
+	    linux kernel and device tree file from a FAT partition.
+	    The default value of 8 MB should be more than adequate.
diff --git a/target/linux/mxs/image/Makefile b/target/linux/mxs/image/Makefile
index 7e6a1a000cd30fbd9b405f3c54ea0236979cc55b..94fed8215c3ea9eb8cf01c909372c0154d58d2e7 100644
--- a/target/linux/mxs/image/Makefile
+++ b/target/linux/mxs/image/Makefile
@@ -7,13 +7,13 @@
 
 include $(TOPDIR)/rules.mk
 include $(INCLUDE_DIR)/image.mk
-include $(INCLUDE_DIR)/host.mk
 
 BOARDS:= \
 	imx23-olinuxino \
 	imx28-duckbill
+
 FAT32_BLOCK_SIZE=1024
-FAT32_BLOCKS=$(shell echo $$(($(CONFIG_MXS_SD_BOOT_PARTSIZE)*1024*1024/$(FAT32_BLOCK_SIZE))))
+FAT32_BLOCKS=$(shell echo $$(($(CONFIG_TARGET_BOOTFS_PARTSIZE)*1024*1024/$(FAT32_BLOCK_SIZE))))
 
 define Image/BuildKernel
 	mkimage -A arm -O linux -T kernel -C none \
@@ -44,37 +44,45 @@ define Image/InstallKernel
 
 endef
 
-define Image/Build/SDCard
+define Image/Build/SDCard-vfat-ext4
 	rm -f $(KDIR)/boot.img
 	mkdosfs $(KDIR)/boot.img -C $(FAT32_BLOCKS)
 
-	mcopy -i $(KDIR)/boot.img $(DTS_DIR)/$(2).dtb ::$(2).dtb
+	mcopy -i $(KDIR)/boot.img $(DTS_DIR)/$(3).dtb ::$(3).dtb
 	mcopy -i $(KDIR)/boot.img $(BIN_DIR)/$(IMG_PREFIX)-uImage ::uImage
 
-	./gen_mxs_sdcard_img.sh \
-		$(BIN_DIR)/$(IMG_PREFIX)-$(PROFILE)-sdcard-vfat-$(1).img \
+	./gen_sdcard_vfat_ext4.sh \
+		$(BIN_DIR)/$(2) \
+		$(BIN_DIR)/uboot-mxs-$(4)/uboot-mxs-$(4).sb \
 		$(KDIR)/boot.img \
 		$(KDIR)/root.$(1) \
-		$(CONFIG_MXS_SD_BOOT_PARTSIZE) \
-		$(CONFIG_TARGET_ROOTFS_PARTSIZE) \
-		$(BIN_DIR)/uboot-mxs-$(3)/uboot-mxs-$(3).sb
+		$(CONFIG_TARGET_BOOTFS_PARTSIZE) \
+		$(CONFIG_TARGET_ROOTFS_PARTSIZE)
+endef
+
+define Image/Build/SDCard-ext4-ext4
+	./gen_sdcard_ext4_ext4.sh \
+		$(BIN_DIR)/$(2) \
+		$(BIN_DIR)/uboot-mxs-$(4)/uboot-mxs-$(4).sb \
+		$(KDIR)/root.$(1) \
+		$(CONFIG_TARGET_ROOTFS_PARTSIZE)
 endef
 
 define Image/Build/Profile/olinuxino-maxi
-	$(call Image/Build/SDCard,$(1),imx23-olinuxino,mx23_olinuxino)
+	$(call Image/Build/SDCard-vfat-ext4,$(1),$(2),imx23-olinuxino,mx23_olinuxino)
 endef
 
 define Image/Build/Profile/olinuxino-micro
-	$(call Image/Build/SDCard,$(1),imx23-olinuxino,mx23_olinuxino)
+	$(call Image/Build/SDCard-vfat-ext4,$(1),$(2),imx23-olinuxino,mx23_olinuxino)
 endef
 
 define Image/Build/Profile/duckbill
-	$(call Image/Build/SDCard,$(1),imx28-duckbill,duckbill)
+	$(call Image/Build/SDCard-ext4-ext4,$(1),$(2),imx28-duckbill,duckbill)
 endef
 
 define Image/Build
 	$(call Image/Build/$(1),$(1))
-	$(call Image/Build/Profile/$(PROFILE),$(1))
+	$(call Image/Build/Profile/$(PROFILE),$(1),$(IMG_PREFIX)-$(PROFILE)-sdcard.img)
 	dd if=$(KDIR)/root.$(1) of=$(BIN_DIR)/$(IMG_PREFIX)-root.$(1) bs=128k conv=sync
 endef
 
diff --git a/target/linux/mxs/image/gen_sdcard_ext4_ext4.sh b/target/linux/mxs/image/gen_sdcard_ext4_ext4.sh
new file mode 100644
index 0000000000000000000000000000000000000000..5653ba892fd25293fe1cf4b013839b1fc2ccca0a
--- /dev/null
+++ b/target/linux/mxs/image/gen_sdcard_ext4_ext4.sh
@@ -0,0 +1,33 @@
+#!/usr/bin/env bash
+#
+# Copyright (C) 2015 OpenWrt.org
+#
+# This is free software, licensed under the GNU General Public License v2.
+# See /LICENSE for more information.
+#
+
+set -x
+[ $# -eq 4 ] || {
+    echo "SYNTAX: $0 <file> <u-boot.sb image> <rootfs image> <rootfs size>"
+    exit 1
+}
+
+OUTPUT="$1"
+UBOOT="$2"
+ROOTFS="$3"
+ROOTFSSIZE="$4"
+
+head=4
+sect=63
+
+# set the Boot stream partition size to 1M
+set `ptgen -o $OUTPUT -h $head -s $sect -l 1024 -t 53 -p 1M -t 83 -p ${ROOTFSSIZE}M -t 83 -p ${ROOTFSSIZE}M`
+
+ROOTFS1OFFSET="$(($3 / 512))"
+ROOTFS1SIZE="$(($4 / 512))"
+ROOTFS2OFFSET="$(($5 / 512))"
+ROOTFS2SIZE="$(($6 / 512))"
+
+dd bs=512 if="$ROOTFS" of="$OUTPUT" seek="$ROOTFS1OFFSET" conv=notrunc
+dd bs=512 if="$ROOTFS" of="$OUTPUT" seek="$ROOTFS2OFFSET" conv=notrunc
+sdimage -d "$OUTPUT" -f "$UBOOT"
diff --git a/target/linux/mxs/image/gen_mxs_sdcard_img.sh b/target/linux/mxs/image/gen_sdcard_vfat_ext4.sh
old mode 100755
new mode 100644
similarity index 73%
rename from target/linux/mxs/image/gen_mxs_sdcard_img.sh
rename to target/linux/mxs/image/gen_sdcard_vfat_ext4.sh
index 7faa8d5de98e21cef4c45bd3312216ab204a4cfd..616639d237c4154e6725421472c373bb890e4ecc
--- a/target/linux/mxs/image/gen_mxs_sdcard_img.sh
+++ b/target/linux/mxs/image/gen_sdcard_vfat_ext4.sh
@@ -1,5 +1,4 @@
 #!/usr/bin/env bash
-
 #
 # Copyright (C) 2015 OpenWrt.org
 #
@@ -7,18 +6,18 @@
 # See /LICENSE for more information.
 #
 
-set -x 
+set -x
 [ $# -eq 6 ] || {
-    echo "SYNTAX: $0 <file> <bootfs image> <rootfs image> <bootfs size> <rootfs size> <u-boot image>"
+    echo "SYNTAX: $0 <file> <u-boot.sb image> <bootfs image> <rootfs image> <bootfs size> <rootfs size>"
     exit 1
 }
 
 OUTPUT="$1"
-BOOTFS="$2"
-ROOTFS="$3"
-BOOTFSSIZE="$4"
-ROOTFSSIZE="$5"
-UBOOT="$6"
+UBOOT="$2"
+BOOTFS="$3"
+ROOTFS="$4"
+BOOTFSSIZE="$5"
+ROOTFSSIZE="$6"
 
 head=4
 sect=63
@@ -33,6 +32,6 @@ BOOTSIZE="$(($4 / 512))"
 ROOTFSOFFSET="$(($5 / 512))"
 ROOTFSSIZE="$(($6 / 512))"
 
-dd bs=512 if="$UBOOT" of="$OUTPUT" seek="$UBOOTOFFSET" conv=notrunc
 dd bs=512 if="$BOOTFS" of="$OUTPUT" seek="$BOOTOFFSET" conv=notrunc
 dd bs=512 if="$ROOTFS" of="$OUTPUT" seek="$ROOTFSOFFSET" conv=notrunc
+sdimage -d "$OUTPUT" -f "$UBOOT"